/* Datei.java */

import javax.persistence.*;
import java.util.Date;

/**
 * Diese Klasse reprsentiert die Tabelle 'file' der 'DirDB'
 * Jede Instanz der Klasse reprsentiert wiederum einen
 * Datensatz
 */

@Entity
@Table( name = "file" )
public class Datei 
{
  @Id
  @GeneratedValue
  @Column(name = "fid")
  private Integer id;

  @Column(name = "fname")                                 
  private String name;

  @Column(name = "dsize")
  private Integer size;

  @Column(name = "fdate")
  private Date date;

  @ManyToOne
  @JoinColumn(name = "did")
  private Verzeichnis directory;

  /**
   * Geschtzter Minimalkonstruktor zur Verwendung von Hibernate
   */
  protected Datei() {
  }

  /**
   * ffentlicher Konstruktor zur Verwendung durch den Entwickler.
   * Dieser Konstruktor definiert alle Pflichtfelder der JavaBean.
   * @param name - Name der Datei
   */
  public Datei(String name)
  {
    this.name = name;
  }

  public Integer getId()
  {
    return id;
  }
  
  protected void setId(Integer id)
  {
    this.id = id;
  }

  public String getName()
  {
    return name;
  }
  
  public void setName(String name)
  {
    this.name = name;
  }

  public Integer getSize()
  {
    return size;
  }
  
  public void setSize(Integer size)
  {
    this.size = size;
  }

  public Date getDate()
  {
    return date;
  }
  
  public void setDate(Date date)
  {
    this.date = date;
  }

  public Verzeichnis getDirectory() 
  {
    return directory;
  }
  
  public void setDirectory(Verzeichnis directory) 
  {
    this.directory = directory;
  }
    
  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;

    Datei file = (Datei) o;
    return !(id != null ? !id.equals(file.id) : file.id != null);
  }

  public int hashCode()
  {
    return id != null ? id.hashCode() : 0;
  }

  public String toString()
  {
    return "File[id:"+ id + ", name:" + name +  "]";
  }
}