/* Listing4708.java */

import javax.persistence.*;

public class Listing4708
{
  public static void main(String[] args)
  {
    //Erzeugen einer EntityManagerFactory mit Hilfe des symbolischen
    //Namens aus dem Persistenz Descriptor (persistence.xml)
    EntityManagerFactory emf =
       Persistence.createEntityManagerFactory("persistenceExample");

    //Erzeugen eines EntityManagers fr den Zugriff auf
    //die Datenbank
    EntityManager manager = emf.createEntityManager();

    //Beginn einer neuen Transanktion
    EntityTransaction tx = manager.getTransaction();
    tx.begin();

    //Laden des Verzeichnis-Objekts mit der Id=0
    Verzeichnis dir = manager.find(Verzeichnis.class, 0); 

    if (dir != null) {
      //Lschen des Datensatzes aus der Datenbank
      manager.remove(dir); 
    }
    
    //Abschluss der Transaktion mit einem Commit
    tx.commit();

    //Freigabe der Ressourcen des EntityManagers
    manager.close();

    //Schlieen der EntityManagerFactory und Freigeben der
    //belegten Ressourcen
    emf.close();
  }
}